#pragma once
#include "B4RDefines.h"

//~version: 1.02
namespace B4R {
	//~shortname: SoftRtc
	class B4RSoftRtc {
		public:
			void SetClock(ArrayByte* datetime, 
							int offset_hours, int offset_minutes);			
			bool ReadClock(ArrayByte* datetime);
			void Initialize(void (*Event) (byte idx), bool tick_every_sec);
			bool SetAlarm(byte Index, ArrayByte* datetime);
			bool CancelAlarm(byte Index);
			ULong DT2Sec(ArrayByte* datetime);
			ArrayByte* Sec2DT(ULong sec);

			static const ULong SECONDS_1MINUTE   = 60;	
			static const ULong SECONDS_1HOUR   = 60*60;
			static const ULong SECONDS_1DAY   = 60*60*24;
			static const ULong SECONDS_1WEEK   = 60*60*24*7;
			
			B4RString* ShortDate(ArrayByte* datetime);
			B4RString* Time12(ArrayByte* datetime);
			B4RString* Time24(ArrayByte* datetime);
			B4RString* ShortDOW(ArrayByte* datetime);
		
		private:
			void start_one_second_tick();
			void SecAsDateTime(ULong sec, byte* dt);
			void extractDateTime(byte* strDT, int L, byte* dt);
			ULong SetAt_millis = 0;
			ULong Set_DateTime_AsSeconds = 0;
			bool tick_every_second = false;
			byte counter = 0;
			byte enabled[10];
			void (*event)(byte idx);
			static void tick(Byte tag, void* target);
	};
}
